//  ViewController.swift
//  ITCS3166CIDR
//  Created by Nazmul Rabbi on 10/17/15
//  only compatible with iphone 6 and iphone 6s doesn't include plus versions

import UIKit

extension String
{
    subscript(integerIndex: Int) -> Character {
        let index = startIndex.advancedBy(integerIndex)
        return self[index]
    }
    
    subscript(integerRange: Range<Int>) -> String {
        let start = startIndex.advancedBy(integerRange.startIndex)
        let end = startIndex.advancedBy(integerRange.endIndex)
        let range = start..<end
        return self[range]
    }
}

class ViewController: UIViewController {
    @IBOutlet weak var inputIP: UITextField!
    @IBOutlet weak var interface0: UIImageView!
    @IBOutlet weak var hostToRouter: UIImageView!
    @IBOutlet weak var routerToInterface0_a: UIImageView!
    @IBOutlet weak var routerToInterface0_b: UIImageView!
    @IBOutlet weak var routerToInterface0_c: UIImageView!
    @IBOutlet weak var routerToInterface0_d: UIImageView!
    @IBOutlet weak var routerToInterface1: UIImageView!
    @IBOutlet weak var routerToRouter1_a: UIImageView!
    @IBOutlet weak var routerToRouter1_b: UIImageView!
    @IBOutlet weak var routerToRouter2_a: UIImageView!
    @IBOutlet weak var routerToRouter2_b: UIImageView!
    @IBOutlet weak var routerToRouter2_c: UIImageView!
    @IBOutlet weak var searchButton: UIButton!
    @IBOutlet weak var resetEnabled: UIButton!
    @IBOutlet weak var interface0ID: UILabel!
    @IBOutlet weak var interface1ID: UILabel!
    @IBOutlet weak var router1ID: UILabel!
    @IBOutlet weak var router2id: UILabel!
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    @IBAction func lookupIP(sender: AnyObject)
    {
        let ipInput = "\(inputIP.text!)"
        
        if ipInput != ""
        {
            var count = 0
            var ipBlockA = ""
            var ipBlockB = ""
            var ipBlockC = ""
            var ipBlockD = ""
            
            while count < ipInput.characters.count && ipInput[count] != "."
            {
                ipBlockA = "\(ipBlockA)" + "\(ipInput[count])"
                count++
            }
            
            count++
            
            while count < ipInput.characters.count && ipInput[count] != "."
            {
                ipBlockB = "\(ipBlockB)" + "\(ipInput[count])"
                count++
            }
            
            count++
            
            while count < ipInput.characters.count && ipInput[count] != "."
            {
                ipBlockC = "\(ipBlockC)" + "\(ipInput[count])"
                count++
            }
            
            count++
            
            while count < ipInput.characters.count && ipInput[count] != "." && ipInput[count] != "/"
            {
                ipBlockD = "\(ipBlockD)" + "\(ipInput[count])"
                count++
            }
            
            let ipBlockAInt = Int(ipBlockA)
            let ipBlockBInt = Int(ipBlockB)
            let ipBlockCInt = Int(ipBlockC)
            let ipBlockDInt = Int(ipBlockD)
            
            var BinaryValueA = String(ipBlockAInt!, radix: 2)
            var BinaryValueB = String(ipBlockBInt!, radix: 2)
            var BinaryValueC = String(ipBlockCInt!, radix: 2)
            var BinaryValueD = String(ipBlockDInt!, radix: 2)
            
            
            while BinaryValueA.characters.count < 8
            {
                BinaryValueA = "0" + "\(BinaryValueA)"
            }
            
            while BinaryValueB.characters.count < 8
            {
                BinaryValueB = "0" + "\(BinaryValueB)"
            }
            
            while BinaryValueC.characters.count < 8
            {
                BinaryValueC = "0" + "\(BinaryValueC)"
            }
            
            while BinaryValueD.characters.count < 8
            {
                BinaryValueD = "0" + "\(BinaryValueD)"
            }
            
            let binaryValueCombined = BinaryValueA + BinaryValueB + BinaryValueC + BinaryValueD
            
            var maskCounter = 0
            var binaryMask = ""
            
            while maskCounter < 22
            {
                binaryMask = binaryMask + "1"
                maskCounter++
            }
            
            while binaryMask.characters.count < 32
            {
                binaryMask = "\(binaryMask)" + "0"
            }
            
            var andCounter = 0
            var andComputation = ""
            
            while andCounter < 32
            {
                if binaryValueCombined[andCounter] == "1" && binaryMask[andCounter] == "1"
                {
                    andComputation = andComputation + "1"
                }
                else
                {
                    andComputation = andComputation + "0"
                }
                
                andCounter++
            }
            
            let interface0 = "10000111001011100011100000000000"
            let interface1 = "10000111001011100011110000000000"
            let router1 = "11000000001101010010100000000000"
            
            if andComputation == interface0
            {
                searchButton.enabled = false
                resetEnabled.enabled = true
                inputIP.userInteractionEnabled = false
                interface0ID.textColor = UIColor.redColor()
                
                UIView.animateWithDuration(2, animations: { () -> Void in
                    self.hostToRouter.alpha = 2
                })
                
                UIView.animateWithDuration(4, animations: { () -> Void in
                    self.routerToInterface0_a.alpha = 4
                })
                
                UIView.animateWithDuration(6, animations: { () -> Void in
                    self.routerToInterface0_b.alpha = 6
                })
                
                UIView.animateWithDuration(8, animations: { () -> Void in
                    self.routerToInterface0_c.alpha = 8
                })
                
                UIView.animateWithDuration(10, animations: { () -> Void in
                    self.routerToInterface0_d.alpha = 10
                })
                
                searchButton.enabled = false
            }
            else if andComputation == interface1
            {
                searchButton.enabled = false
                resetEnabled.enabled = true
                inputIP.userInteractionEnabled = false
                interface1ID.textColor = UIColor.redColor()
                
                UIView.animateWithDuration(2, animations: { () -> Void in
                    self.hostToRouter.alpha = 2
                })
                
                UIView.animateWithDuration(4, animations: { () -> Void in
                    self.routerToInterface0_a.alpha = 4
                })
                
                UIView.animateWithDuration(6, animations: { () -> Void in
                    self.routerToInterface1.alpha = 6
                })
                
            }
            else if andComputation == router1
            {
                searchButton.enabled = false
                resetEnabled.enabled = true
                inputIP.userInteractionEnabled = false
                router1ID.textColor = UIColor.redColor()
                
                UIView.animateWithDuration(2, animations: { () -> Void in
                    self.hostToRouter.alpha = 2
                })
                
                UIView.animateWithDuration(4, animations: { () -> Void in
                    self.routerToRouter1_a.alpha = 4
                })
                
                UIView.animateWithDuration(6, animations: { () -> Void in
                    self.routerToRouter1_b.alpha = 6
                })
            }
            else
            {
                searchButton.enabled = false
                resetEnabled.enabled = true
                inputIP.userInteractionEnabled = false
                router2id.textColor = UIColor.redColor()
                
                UIView.animateWithDuration(2, animations: { () -> Void in
                    self.hostToRouter.alpha = 2
                })
                
                UIView.animateWithDuration(4, animations: { () -> Void in
                    self.routerToRouter1_a.alpha = 4
                })
                
                UIView.animateWithDuration(6, animations: { () -> Void in
                    self.routerToRouter2_a.alpha = 6
                })
                
                UIView.animateWithDuration(8, animations: { () -> Void in
                    self.routerToRouter2_b.alpha = 8
                })
                
                UIView.animateWithDuration(10, animations: { () -> Void in
                    self.routerToRouter2_c.alpha = 10
                })
            }
        }
    }

    @IBAction func resetSwitch(sender: AnyObject)
    {
        inputIP.text = ""
        searchButton.enabled = true
        resetEnabled.enabled = false
        inputIP.userInteractionEnabled = true
        interface0ID.textColor = UIColor.blackColor()
        interface1ID.textColor = UIColor.blackColor()
        router1ID.textColor = UIColor.blackColor()
        router2id.textColor = UIColor.blackColor()
        
        UIView.animateWithDuration(2, animations: { () -> Void in
            self.hostToRouter.alpha = 0
            self.routerToInterface0_a.alpha = 0
            self.routerToInterface0_b.alpha = 0
            self.routerToInterface0_c.alpha = 0
            self.routerToInterface0_d.alpha = 0
            self.routerToInterface1.alpha = 0
            self.routerToRouter1_a.alpha = 0
            self.routerToRouter1_b.alpha = 0
            self.routerToRouter2_a.alpha = 0
            self.routerToRouter2_b.alpha = 0
            self.routerToRouter2_c.alpha = 0
        })
    }
    
    override func viewDidAppear(animated: Bool)
    {
        resetEnabled.enabled = false
        hostToRouter.alpha = 0
        routerToInterface0_a.alpha = 0
        routerToInterface0_b.alpha = 0
        routerToInterface0_c.alpha = 0
        routerToInterface0_d.alpha = 0
        routerToInterface1.alpha = 0
        routerToRouter1_a.alpha = 0
        routerToRouter1_b.alpha = 0
        routerToRouter2_a.alpha = 0
        routerToRouter2_b.alpha = 0
        routerToRouter2_c.alpha = 0
    }
}

